<template>
  <v-toolbar dense app extended extension-height="4" :class="color">
    <v-toolbar-title>
      {{title}}
    </v-toolbar-title>
    <v-spacer></v-spacer>
    <v-toolbar-title v-if="isMobile">
      <small>{{ totalTasksRemaining }}</small>
    </v-toolbar-title>
    <v-menu
      v-model="userDrawer.show"
      :close-on-content-click="false"
      offset-y
    >
      <template v-slot:activator="{ on }">
        <v-btn v-on="on" icon>
            <v-icon large>person_outline</v-icon>
        </v-btn>
      </template>
      <v-card>
        <v-list>
          <v-list-tile avatar>
            <v-list-tile-content>
              <v-list-tile-title>{{ $store.getters['user/getName'] }}</v-list-tile-title>
              <v-list-tile-sub-title>{{ $store.getters['user/getMail'] }}</v-list-tile-sub-title>
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
        <v-divider class="hidden-sm-and-up" v-if="$store.getters['user/getList']"></v-divider>
        <v-list style="height: 50vh; overflow-y: auto" class="hidden-sm-and-up" v-if="$store.getters['user/getList']">
          <v-list-tile
            v-for="(item, id) in $store.getters['user/getList']"
            :key="id"
          >
            <v-list-tile-action @click="loadList(item)">
              <v-icon>assignment</v-icon>
            </v-list-tile-action>

            <v-list-tile-content
              @click="loadList(item)">
              <v-list-tile-title>{{ item.title }}</v-list-tile-title>
            </v-list-tile-content>

            <v-list-tile-action>
              <v-btn round fab small flat color="primary" @click="editList(item)" type="button">
                <v-icon>edit</v-icon>
              </v-btn>
            </v-list-tile-action>
          </v-list-tile>
        </v-list>
        <v-divider></v-divider>
        <v-list>
          <v-list-tile
            key="-2"
            @click="createList()"
          >
            <v-list-tile-action>
              <v-icon>add</v-icon>
            </v-list-tile-action>

            <v-list-tile-content>
              <v-list-tile-title>New list</v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>
          <v-list-tile
            key="-3"
            @click="desc = !desc"
          >
            <v-list-tile-action>
              <v-icon v-if="!desc">check_box_outline_blank</v-icon>
              <v-icon v-else color="green">check_box</v-icon>
            </v-list-tile-action>

            <v-list-tile-content>
              <v-list-tile-title>Show task description</v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
        <v-divider></v-divider>
        <v-list>
          <v-list-tile
            v-for="item in menu"
            :key="item.title"
            :to="{ name: item.name }"
          >
            <v-list-tile-action>
              <v-icon>{{ item.icon }}</v-icon>
            </v-list-tile-action>

            <v-list-tile-content>
              <v-list-tile-title>{{ item.title }}</v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
      </v-card>
    </v-menu>
    <progress-bar
      :loading="isLoading"
      color="deep-purple accent-4"
      slot="extension"
    />
  </v-toolbar>
</template>

<script>
import progressBar from '@/components/NavBar/ProgressBar'

import UserService from '@/services/UserService'
import ErrorService from '@/services/ErrorService'

import { mapGetters } from 'vuex'

export default {
  name: 'HeaderBar',
  components: {
    'progress-bar': progressBar
  },
  computed: {
    getCompletion: function () {
      if (this.listToLoad === null) {
        return 0
      }
      console.log(this.listToLoad)
      return this.listToLoad.nbCompletedTask / this.listToLoad.nbTask * 100
    },
    totalTasksRemaining: function () {
      if (this.listToLoad === null) {
        return
      }
      return '(' + this.listToLoad.nbCompletedTask + '/' + this.listToLoad.nbTask + ')'
    },
    ...mapGetters({
      isLoading: 'isLoading',
      listToLoad: 'listToLoad',
      isMobile: 'isMobile',
      showDescription: 'showDescription'
    })
  },
  data () {
    return {
      userService: new UserService(),
      errorService: new ErrorService(),
      userDrawer: {
        show: null
      },
      menu: [
        // { title: 'Profile', icon: 'far fa-id-card', name: 'Profile' },
        { title: 'Logout', icon: 'fas fa-power-off', name: 'Logout' }
      ],
      desc: false,
      color: 'blue',
      title: 'Todo list'
    }
  },
  created () {
    this.desc = this.$store.getters['showDescription']
  },
  watch: {
    desc: function (val) {
      if (val === null) {
        return
      }
      this.$store.commit('showDescription', val)
      this.userDrawer.show = false
      this.userService.updateShowDescription(val).then(() => {
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
      })
    },
    listToLoad: function (val) {
      if (this.isMobile) {
        if (val) {
          this.title = val.title
          this.color = val.color
        } else {
          this.title = 'Todo list'
          this.color = 'blue'
        }
      } else {
        this.title = 'Todo list'
        this.color = 'blue'
      }
    },
    showDescription: function (val) {
      this.desc = val
    }
  },
  methods: {
    loadList: function (item) {
      this.userDrawer.show = false
      this.$store.commit('changeList', item)
    },
    createList: function () {
      this.userDrawer.show = false
      this.$store.commit('addList', true)
    },
    editList: function (item) {
      this.userDrawer.show = false
      this.$store.commit('editList', item)
    }
  }
}
</script>

<style>
.v-toolbar__extension {
  padding: 0px !important;
}
</style>
